package util;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeUnit;

import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.http.HttpResponse;

import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import net.jodah.expiringmap.ExpirationPolicy;
import net.jodah.expiringmap.ExpiringMap;


@Service
public class MessageUtil {
   
	private static final String oauth2_tokenurl ="https://poa..poa域名地址(联系项目经理提供)/oauth2/token";
	
	private static final String MESSAGE_SEND = "https://poa..poa域名地址(联系项目经理提供)/apis/messagecenter/v1/poaMessage/messageSend";
	
	private static final String APPID ="a132c4c0c52a11ec5fa415e4485f32e0";
	
	private static final String MESSAGETYPECODE ="MT1650954853000";
	
	
	
	
	private static final String client_id ="xcfvGIgSgAu5yo85-xNYAXJi72k=";
	private static final String client_secret ="laRffpmQ9Dp6wr6_pYVq5gV9zSB5OdXl-wmR7Sv0kt8=";
	private static final String scope ="ttc:v1:writeTransaction,ttc:v1:writeTtc,messagecenter:v1:sendMessage";
	

	private static final ExpiringMap<String, String> expireToken = ExpiringMap.builder()
			.maxSize(110)		
			.variableExpiration().expirationPolicy(ExpirationPolicy.CREATED).build();
	
	
	
private String getContactsAccessToken() {
	    	String contactsAccessToken = "";
			if(expireToken!=null && expireToken.get("access_token")!=null) {
				contactsAccessToken = expireToken.get("access_token").toString();
	    	}else {
            //获取到poa token
	    		JSONObject resultJsonObject = getAccessTokenObject();
	    		contactsAccessToken = resultJsonObject.getString("access_token");
	        int expires_in = resultJsonObject.getInteger("expires_in")-100;
	        expireToken.put("access_token", contactsAccessToken,expires_in, TimeUnit.SECONDS);

	    	}
			
			System.out.println("token:"+contactsAccessToken);
			 
			 return contactsAccessToken; 
	   
	  }
	
	
	public static void main(String[] args) {
		MessageUtil MessageUtil=new MessageUtil();
		MessageUtil.sendMessage();
    
		
	
	}
	
	
	
  
	
	
    /**
     * 发送短信
     *
     * @param code
     * @return
     */
    public boolean sendMessage()
    {
    	
        
        Map<String, Object> headers = new HashMap<String, Object>();
        
        JSONObject parameters = new JSONObject();
		parameters.put("appId", APPID);    //消息服务对接的应用ID  (应用ID(必填))
		parameters.put("messageTypeCode", MESSAGETYPECODE);   //消息服务对接的应用内的消息类型编码， (消息类型编码（(必填)）【消息类型编码由应用申请消息类型产生，消息类型定义模板】)		
		parameters.put("sendId", ""); //	string (消息任务发送序列号，唯一【为空，消息服务生成唯一sendId,并返回】)
		parameters.put("toPhones", "13083008175"); //	string (接收手机号，多个英文逗号分隔)
		//parameters.put("sendTime", "xxxx"); //string (定时发送时间【yyyy-MM-dd HH:mm:ss】)
		//parameters.put("toPersons", "xxxx"); //string (接收人账号，多个英文逗号分隔)
		//parameters.put("toDepts", "xxxx"); //string (接收部门id，多个英文逗号分隔)
		//parameters.put("toGroups", "xxxx"); //	string (接收用户组id，多个英文逗号分隔)
		//parameters.put("toEmails", "xxxx"); //string (接收邮箱，多个英文逗号分隔)
		//parameters.put("excludeUser", "xxxx"); //	string (排除接收人学工号,多个用英文逗号分割)
		//parameters.put("signOff", "hzysign"); //	string (落款)
		JSONArray sendType = new JSONArray(); // Array of strings (发送方式) 如果发送方式不传，则以后台配置的消息类型默认发送方式来发送  
		sendType.add("SMS");
		parameters.put("sendType", sendType);
		parameters.put("promise", true); //  (消息送达承诺【如果是，校验比较严格】)
		parameters.put("importantIdentity", true); //boolean (是否重要消息标识)
		JSONObject data = new JSONObject();
		data.put("title", "测试hzy"); //string (消息标题(必填))
		//data.put("handleKey", "xxx"); //string (处理字段；APP跳转预设的KEY或者是接收方要处理的地址等【如果为空，默认设置该消息任务的账号唯一key】)
		//data.put("coverImageUrl", "xxx"); // string (封面图URL)
		//data.put("filesUrl", "xxx"); //string (附件url,多附件英文逗号分隔【后续提供文件服务，暂不支持】)
		//data.put("mobileUrl", "xxx"); //string (移动端跳转链接)
		//data.put("url", "xxx");  //string (pc端跳转链接)
		JSONObject paramValueJson = new JSONObject(); // object (消息类型模板定义的变量&值)
		paramValueJson.put("name", "hzy");
		paramValueJson.put("tname", "thzy");
		data.put("paramValueJson", paramValueJson);
		parameters.put("data", data);
		
        
        String entity = parameters.toJSONString();

        JSONObject resultJsonObject = null;
        	 
        String contactsAccessToken = getContactsAccessToken();
          
        headers.put("Authorization", contactsAccessToken);
          HttpResponse httpResponse = null;
          try {
            httpResponse = HttpUtil.execute(MESSAGE_SEND, "POST", null, null, parameters, headers, entity);
            
            resultJsonObject = parseJSONObject(httpResponse);
            
            if (resultJsonObject != null) {
            	
              if (resultJsonObject.getIntValue("code")==0) {
                  String rsdata = resultJsonObject.getString("data");
            	  System.out.println("-----创建成功返回taskIds:-------"+data);
            	  return true;
              } else if( resultJsonObject.getIntValue("code")==-1)  {
            	  System.out.print("-----error-------"+resultJsonObject.getString("message"));
              }       
            }
            
           
           
          } catch (Exception e) {
            e.printStackTrace();
          } finally {
            HttpUtil.close(httpResponse);
          }
        
        
        return false;
    }
    
   
    
    private static JSONObject getAccessTokenObject() {
		 String tokenUrl = oauth2_tokenurl;
	        String grantType = "client_credentials";
	        NameValuePair[] data = {
	                new NameValuePair("grant_type", grantType),
	                new NameValuePair("client_id", client_id),
	                new NameValuePair("client_secret", client_secret),
	                new NameValuePair("scope", scope)               
	        };
		 
	        String httpResponse = null;
	        JSONObject resultJsonObject = null;
	        try { 
	            httpResponse = postx(tokenUrl, data);
	            //。。超时等重发略写
	             resultJsonObject =  JSONObject.parseObject(httpResponse);
	        } catch (Exception e) {
	            e.printStackTrace();
	            //todo you need
	        } 
	       
	        return resultJsonObject;
	    }


	 private static JSONObject parseJSONObject(HttpResponse httpResponse) {
		    try {
		      if (httpResponse != null) {
		        StringBuilder entityStringBuilder = new StringBuilder();
		  
		        BufferedReader b = new BufferedReader(new InputStreamReader(httpResponse.getEntity().getContent(), "UTF-8"), 8*1024);
		  
		        String line=null;
		        while ((line=b.readLine())!=null) {
		          entityStringBuilder.append(line);
		        }
		        
		        
		        JSONObject resultJsonObject = JSONObject.parseObject(entityStringBuilder.toString());
		        
		        return resultJsonObject;
		      }
		    } catch (UnsupportedEncodingException e) {
		      e.printStackTrace();
		    } catch (UnsupportedOperationException e) {
		      e.printStackTrace();
		    } catch (IOException e) {
		      e.printStackTrace();
		    }
		    
		    return null;
		  }
	
	
	
	
	// 发送x-www-form-urlencoded格式数据
	    public static String postx(String url ,NameValuePair[] data) {
	    try {       
	        PostMethod postMethod = null;
	        postMethod = new PostMethod(url) ;
	        postMethod.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8") ;
	    //参数设置，需要注意的就是里边不能传NULL，要传空字符串        
	        postMethod.setRequestBody(data);

	        org.apache.commons.httpclient.HttpClient httpClient = new org.apache.commons.httpclient.HttpClient();
	        int response = httpClient.executeMethod(postMethod); // 执行POST方法
	        String result = postMethod.getResponseBodyAsString() ;
	        System.out.println("--------"+response);
	        System.out.println("===="+result);
	        return result;
	    } catch (Exception e) {
	      
	        throw new RuntimeException(e.getMessage());
	    }
	    }
	
	
	
}
